package control;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Insieme;
import model.InsiemeSequenza;

/**
 *
 * @author Gianni
 */
public class GestoreEventi {
  protected final String path="dati/";//contiene pochi dati ben verificabili
//  protected final String path="dati/bis/";//contiene dati casuali
  protected final String sociFilename="soci.txt";
  protected final String presentiFilename[]={"presenti1.txt","presenti2.txt","presenti3.txt","presenti4.txt","presenti5.txt"};
  private Insieme<String> soci;
  public GestoreEventi(){
    Scanner lettore;
    try {
      lettore = new Scanner(new File(path+sociFilename));
      soci = new InsiemeSequenza<String>();
      while (lettore.hasNext()){
        soci.includi(lettore.nextLine());
      }
      System.out.println("Soci="+soci);
    } catch (FileNotFoundException ex) {
      System.out.println("File soci non trovato in GestoreEventi:"+ex);
    }
  }
  public void quesitoA(){
    Scanner lettore;
    String presente;
    System.out.println("* Quesito B2.A");
    for (int i = 0; i < presentiFilename.length; i++) {      
      try {
        String filename = presentiFilename[i];
        lettore = new Scanner(new File(path+filename));
        System.out.println("Elenco dei non soci presenti all'evento "+i);
        while (lettore.hasNext()){
          presente=lettore.nextLine();
          if (!soci.appartiene(presente)){
            System.out.println(presente);
          } 
        }       
      } catch (FileNotFoundException ex) {
        System.out.println("File presenti non trovato in QuesitoA:"+ex);
      }
    }
  }
  public void quesitoB(){
    //insieme dei soci da cui caver i presenti
    Insieme<String> sociAssenti = soci.clone();
    Scanner lettore;
    System.out.println("* Quesito B2.B");
    for (int i = 0; i < presentiFilename.length; i++) {      
      try {
        String filename = presentiFilename[i];
        lettore = new Scanner(new File(path+filename));
        //soci presenti all'evento i
        while (lettore.hasNext()){
          sociAssenti.escludi(lettore.nextLine());
        }       
      } catch (FileNotFoundException ex) {
        System.out.println("File presenti non trovato in QuesitoB:"+ex);
      }
    }
    try {
      lettore = new Scanner(new File(path+sociFilename));
      String assente;
      System.out.println("Elenco dei soci non presenti ad alcun evento ");
      while (lettore.hasNext()){
        assente=lettore.nextLine();
        if (sociAssenti.appartiene(assente)){
          System.out.println(assente);
        } 
      }       
    } catch (FileNotFoundException ex) {
      System.out.println("File soci non trovato in QuesitoB:"+ex);
    }    
  }
}
