package control;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.StackArray;

/**
 * Dato un text file si vuole ottenere un altro text file che contiene le stesse
 * linee del primo file, ma nell'ordine inverso, cio la prima linea di input 
 * sar l'ultima di output, la seconda diventa penultima e cos via fino 
 * all'ultima linea di input che sar la prima di output.
 * @author Gianni
 */
public class TextFileInverter {
  private File fIn,fOut;

  public TextFileInverter(File fIn, File fOut) {
    this.fIn = fIn;
    this.fOut = fOut;
  }
  
  public void inverti(){
    try {
      //preparo gli oggetti necessari
      StackArray<String> s = new StackArray<String>();
      Scanner lettore = new Scanner(fIn);
      PrintWriter scrittore = new PrintWriter(fOut);
      //scansione di tutte le lline di ingresso e carico in stack
      while (lettore.hasNext()){
        s.push(lettore.nextLine());
      }
//      System.out.println("stack="+s);//solo per test
      //dallo stack estraggo e salvo su file output
      while (!s.isEmpty()){
//        System.out.println("stack="+s);//solo per test
        scrittore.println(s.pop());
      }
      scrittore.close();
    } catch (FileNotFoundException ex) {
      Logger.getLogger(TextFileInverter.class.getName()).log(Level.SEVERE, null, ex);
    }
    
  }
  
}
