package model;

/**
 *
 * @author Gianni
 */
public class InsiemeSequenza<T extends Comparable<T>> implements Insieme<T> {
  protected SequenzaArray<T> dati;

  public InsiemeSequenza() {
    dati=new SequenzaArray<T>();
  }

  @Override
  public boolean appartiene(T elem) {
    boolean trovato=false;
    for (int i = 0; i < dati.getLunghezza() && !trovato; i++) {
      trovato=elem.compareTo(dati.getElemento(i))==0;      
    }
    return trovato;
  }

  @Override
  public Insieme<T> differenza(Insieme<T> ins) {
    Insieme<T> nuovo = this.clone();
    for (int i = 0; i < dati.getLunghezza(); i++) {
      if(ins.appartiene(dati.getElemento(i))) {
        nuovo.escludi(dati.getElemento(i));
      }
    }
    return nuovo;
  }

  @Override
  public void escludi(T elem) {
    boolean trovato=false;
    for (int i = 0; i < dati.getLunghezza() && !trovato; i++) {
      trovato=elem.compareTo(dati.getElemento(i))==0;     
      if (trovato){
        dati.elimina(i);
      }
    }
  }

  @Override
  public void includi(T elem) {
    boolean trovato=false;
    for (int i = 0; i < dati.getLunghezza() && !trovato; i++) {
      trovato=elem.compareTo(dati.getElemento(i))==0;      
    }
    if (!trovato){
      dati.appendi(elem);
    }
  }

  @Override
  public Insieme<T> intersezione(Insieme<T> ins) {
    Insieme<T> nuovo = new InsiemeSequenza<T>();
    for (int i = 0; i < dati.getLunghezza(); i++) {
      if (ins.appartiene(dati.getElemento(i))){
        nuovo.includi(dati.getElemento(i));
      }
    }
    return nuovo;
  }

  @Override
  public boolean isEmpty() {
    return dati.isEmpty();
  }

  @Override
  public Insieme<T> unione(Insieme<T> ins) {
    Insieme<T> nuovo=ins.clone();
    for (int i = 0; i < dati.getLunghezza(); i++) {
      nuovo.includi(dati.getElemento(i));
    }
    return nuovo;
  }

  @Override
  public Insieme<T> clone() {
    Insieme<T> nuovo=new InsiemeSequenza<T>();
    for (int i = 0; i < dati.getLunghezza(); i++) {
      nuovo.includi(dati.getElemento(i));
    }
    return nuovo;
  }

  @Override
  public String toString() {
    return "InsiemeSequenza{" + "dati=" + dati + '}';
  }
  
}
