/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

/**
 *
 * @author Gianni
 */
public class SequenzaArray<T> implements Sequenza<T> {
  private T[] dati;
  private int lunghezzaEffettiva;
  private final int DEFAULTMAXDATI = 100;

  /**
   * costruttore: istanzia un asequenza vuota
   */
  public SequenzaArray() {
    dati=(T[])new Object[DEFAULTMAXDATI];
    lunghezzaEffettiva=0;
  }

  public SequenzaArray(int maxdati) {
    dati=(T[])new Object[maxdati];
    lunghezzaEffettiva=0;
  }

  @Override
  public void appendi(T dato) {
    if(lunghezzaEffettiva==dati.length){
        //NB si veda http://docs.oracle.com/javase/tutorial/essential/exceptions/runtime.html
        throw new RuntimeException("Overflow su sequenza");
    }
    dati[lunghezzaEffettiva]=dato;
    lunghezzaEffettiva++;
  }

  @Override
  public void elimina(int i) {
    if (i<0 || i >=lunghezzaEffettiva){
      throw new RuntimeException("Indice fuori limiti");
    }
    for (int j = i; j < lunghezzaEffettiva-1; j++) {
      dati[j]=dati[j+1];
    }
    lunghezzaEffettiva--;
    dati[lunghezzaEffettiva]=null;//non indispensabile, ma meglio essere puliti, libera la memoria
  }

  @Override
  public T getElemento(int i) {
    if (i<0 || i >=lunghezzaEffettiva){
      throw new RuntimeException("Indice fuori limiti");
    }
    return dati[i];
  }

  @Override
  public int getLunghezza() {
    return lunghezzaEffettiva;
  }

  @Override
  public void inserisci(T dato, int i) {
    if(lunghezzaEffettiva==dati.length){
        throw new RuntimeException("Overflow su sequenza");
    }
    if (i<0 || i >=lunghezzaEffettiva){
      throw new RuntimeException("Indice fuori limiti");
    }
    for(int j=lunghezzaEffettiva;j>i;j--){
      dati[j]=dati[j-1];
    }
    dati[i]=dato;
    lunghezzaEffettiva++;
  }

  @Override
  public boolean isEmpty() {
    return lunghezzaEffettiva==0;
  }

  @Override
  public String toString() {
    String out="";
    out += "SequenzaArray{" + "dati={";
//        out += dati;
    for (int i=0;i<lunghezzaEffettiva;i++){
        if (i!=0){
          out+=",";
        }
        out+=dati[i];
    }
    out += "}, lunghezzaEffettiva=" + lunghezzaEffettiva + ", DEFAULTMAXDATI=" + DEFAULTMAXDATI + ", maxdati="+dati.length+'}';
    return out;
  }
  
}
