package model;

/**
 * ADT stack, descrive le propriet base della catasta (LIFO)
 * Le eventuali condizioni di errore vanno gestite producendo eccezioni uncatched.
 * @author giovanni.ragno
 */
public interface Stack<T> {
  /**
   * Inserisce un dato in cima allo stack
   * @param dato da inserire
   */
  void push(T dato);
  /**
   * Restituisce ed elimina il dato in cima allo stack
   * @return il dato
   */
  T pop();
  /**
   * Test se lo stack  vuoto
   * @return true se vuoto, false in caso contrario
  */
  boolean isEmpty();
}
