package model;

/**
 *
 * @author Gianni
 */
public class StackArray<T> implements Stack<T> {
  private T[] dati;
  private int lunghezzaEffettiva;
  private final int DEFAULTMAXDATI = 100;
  /**
   * costruttore: istanzia un asequenza vuota
   */
  public StackArray() {
    dati=(T[])new Object[DEFAULTMAXDATI];
    lunghezzaEffettiva=0;
  }

  public StackArray(int maxdati) {
    dati=(T[])new Object[maxdati];
    lunghezzaEffettiva=0;
  }

  @Override
  public boolean isEmpty() {
    return lunghezzaEffettiva==0;
  }

  @Override
  public  T  pop() {
    if(lunghezzaEffettiva==0){
        throw new RuntimeException("Underflow su stack");
    }
    lunghezzaEffettiva--;
    T rit= dati[lunghezzaEffettiva];
    dati[lunghezzaEffettiva]=null;//non indispensabile, ma meglio essere puliti, libera la memoria
    return rit;
  }

  @Override
  public void push(T dato) {
    if(lunghezzaEffettiva==dati.length){
        throw new RuntimeException("Overflow su stack");
    }
    dati[lunghezzaEffettiva]=dato;
    lunghezzaEffettiva++;
  }

  @Override
  public String toString() {
    String out="";
    out += "StackArray{" + "dati={";
//        out += dati;
    for (int i=0;i<lunghezzaEffettiva;i++){
        if (i!=0){
          out+=",";
        }
        out+=dati[i];
    }
    out += "}, lunghezzaEffettiva=" + lunghezzaEffettiva + ", DEFAULTMAXDATI=" + DEFAULTMAXDATI + ", maxdati="+dati.length+'}';
    return out;
  }
  
}
