/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ver131217;

import control.GestoreEventi;
import control.GestoreEventiIter;
import control.PalindromoChecker;
import control.TextFileInverter;
import java.io.File;
import model.*;

/**
 *
 * @author Gianni
 */
public class Ver131217 {

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    /*
     * Esercizi "Teasto A"
     */
    //
    //Eserc. A1, test della classe stack
    testStack(new StackArray<Integer>());
    //Eserc. A2, inversione file
    inversioneFile();
    //Eserc. A3, inversione file
    testPalindroma("ailatiditalia");
    testPalindroma("aibordiditalia");
    testPalindroma("a");
    testPalindroma("aa");
    testPalindroma("");
    testPalindroma("x x");
    testPalindroma("x x ");
    testPalindroma("i topi non avevano nipoti");
    testPalindroma("itopinonavevanonipoti");
    
    /*
     * Esercizi "Testo B"
     */
    //Eserc. B1, test della classe InsiemeSequenza
    testInsieme(new InsiemeSequenza<Integer>());
    //Eserc B2 e B3
    gestioneEventi();
  }
  
  /**
   * Metrodo di test delle funzionalit previste per la classe Stack
   * @param si oggetto di prova che si suppone vuoto
   */
  public static void testStack(Stack<Integer> si) {
    System.out.println("TEST della classe Stack<Integer>");
    System.out.println("si="+si); //vuoto
    System.out.println("** Push **");
    si.push(1);
    System.out.println("si="+si);//1
    si.push(2);
    System.out.println("si="+si);//1,2
    si.push(3);
    System.out.println("si="+si);//1,2,3
    System.out.println("** Pop **");
    System.out.println("si.pop="+si.pop());
    System.out.println("si="+si);//1,2
    System.out.println("si.pop="+si.pop());
    System.out.println("si="+si);//1
    System.out.println("si.pop="+si.pop());
    System.out.println("si="+si);//vuoto      
    System.out.println("Fine TEST della classe Stack<Integer>");
  }
  
  /**
   * Dato il file ?elenco.txt? si vuole ottenere il file ?inverso.txt? che contiene
   * le stesse linee del primo file, ma nell'ordine inverso, cio la prima linea
   * di ?elenco? sar l'ultima di ?inverso?, la seconda diventa penultima e cos
   * via fino all'ultima linea di ?elenco? che sar la prima di ?inverso?.
   */
  public static void inversioneFile(){
    System.out.println("Esecuzione Esercizio A2");
    String fileInName="elenco.txt";
    String fileOutName="inverso.txt";
    TextFileInverter inverter = new TextFileInverter(new File("dati/"+fileInName),new File("dati/"+fileOutName));
    inverter.inverti();
    System.out.println("Fine esecuzione Esercizio A2");
  }
  
  /**
   * data una stringa determina se  palindroma utilizzando lo stack
   * @param s la stringa da esaminare
   */
  public static void testPalindroma(String s){
    System.out.println("Esecuzione Esercizio A3");
    PalindromoChecker checker = new PalindromoChecker(s);
    if (checker.isPalindroma()){
      System.out.println(s+" = Palindroma");
    }
    else {
      System.out.println(s+" = Non palindroma");
    }
    System.out.println("Fine esecuzione Esercizio A3");
  }
  
  /**
   * Metrodo di test delle funzionalit previste per la classe Insieme
   * @param ii oggetto di prova che si suppone vuoto
   */
  public static void testInsieme(Insieme<Integer> ii) {
    System.out.println("TEST della classe Insieme<Integer>");
    System.out.println("ii="+ii);//vuoto
    System.out.println("** Includi **");
    ii.includi(5);
    System.out.println("ii="+ii);//5
    ii.includi(5);
    System.out.println("ii="+ii);//ancora solo 5, nessun errore
    ii.includi(3);
    System.out.println("ii="+ii);//5,3
    ii.includi(71);
    System.out.println("ii="+ii);//5,3,71
    ii.includi(12);
    System.out.println("ii="+ii);//5,3,71,12
    ii.includi(5);
    System.out.println("ii="+ii);//5,3,71,12
    System.out.println("** Escludi **");
    ii.escludi(2);
    System.out.println("ii="+ii);//5,3,71,12 nessun errore 
    System.out.println("71?="+ii.appartiene(71));//true
    ii.escludi(71);
    System.out.println("ii="+ii);//5,3,12
    System.out.println("71?="+ii.appartiene(71));//false
    System.out.println("** Clone **");
    Insieme<Integer> nuovo=ii.clone();
    System.out.println("nuovo="+nuovo);//5,3,12
    ii.escludi(5);
    ii.includi(9);
    ii.includi(3);
    System.out.println("ii="+ii);//3,12,9
    System.out.println("nuovo="+nuovo);//5,3,12, nuovo e ii sono indipendenti
    System.out.println("** Unione **");
    System.out.println("ii unione nuovo="+ii.unione(nuovo));//5,3,12,9
    System.out.println("ii="+ii);//non modificato da unione
    System.out.println("nuovo="+nuovo);//non modificato da unione
    System.out.println("nuovo unione ii="+nuovo.unione(ii));//5,3,12,9
    System.out.println("ii unioneii="+ii.unione(ii));//3,12,9
    System.out.println("ii="+ii);//non modificato da unione
    System.out.println("** Intersezione **");
    System.out.println("ii intersezione nuovo="+ii.intersezione(nuovo));//3,12
    System.out.println("ii="+ii);//non modificato da intersezione
    System.out.println("nuovo="+nuovo);//non modificato da intersezione
    System.out.println("nuovo intersezione ii="+nuovo.intersezione(ii));//3,12
    System.out.println("ii intersezione ii="+ii.intersezione(ii));//3,12,9
    System.out.println("ii="+ii);//non modificato da intersezione
    System.out.println("** Differenza **");
    System.out.println("ii differenza nuovo="+ii.differenza(nuovo));//9
    System.out.println("ii="+ii);//non modificato da differenza
    System.out.println("nuovo="+nuovo);//non modificato da differenza
    System.out.println("nuovo differenza ii="+nuovo.differenza(ii));//5
    System.out.println("ii differenza ii="+ii.differenza(ii));//vuoto
    System.out.println("ii="+ii);//non modificato da differenza
    System.out.println("Fine TEST della classe Insieme<Integer>");
  }
  public static void gestioneEventi(){
    //Eserc. B2
    GestoreEventi ge = new GestoreEventi();
    ge.quesitoA();
    ge.quesitoB();
    //Eserc. B3 miglioro lo sviluppo se implemento l'insieme come iterabile
    GestoreEventiIter gi = new GestoreEventiIter();
    gi.quesitoA();
    gi.quesitoB();
  }
}
